unit Faslocat;
{************************************************
{   Location of Interfereing Fastener Object                                                                      }
{   Delphi
{   Copyright (c) 1998 2005
{   Innova Solutions/R Connell              }
{************************************************}
interface
uses Classes, sysutils, Forms;
type
  TLocation = class(TObject)
  public
    ImpactObject: TObject;              //Zero >> Edge non zero >> Fastener is Fastener pointer only for Drawing
    Xloc, Yloc: Real;
    function TextValue: string;
    function IsEdge: Boolean;
    destructor Destroy; override;
  end;

  TLocClass = class of TLocation;

implementation
uses math;


function TLocation.TextValue: string;
  {sub}function TextVal(val:real):string;
        begin
         Result:= FormatFloat('###0.0',val)+'mm';
        end;
var
  s            : string;
begin
  if IsEdge then
    begin
      s:= 'Edge at';
      if Round(YLoc) = 0 then           {Sin 0 =.000000000001}
        s:=s + ' X=' + TextVal(XLoc)
      else
        if (Round(XLoc) = 0) then
          s:=s + ' Y=' + TextVal(YLoc)
        else
          S:= 'Edge Thru ' + TextVal(XLoc) + ',' +
            TextVal(YLoc);
    end
  else
    begin
      s:= 'X ' + TextVal(XLoc) + ',Y ' + TextVal(YLoc);
    end;
  TextValue:=s;
end;

function TLocation.IsEdge: Boolean;
begin
  IsEdge:=ImpactObject = nil;
end;




destructor TLocation.Destroy;
begin
  ImpactObject.Free;
  inherited;
end;

end.

