unit Fastener;

interface
 uses FasArrayCalObjcts, Graphics, Types;
Type

  TFastener=class(TObject)
    SupportedShearLoad,SupportedTensionLoad:Real;
   procedure DrawPlanNut(Canvas: TCanvas; x, y: Integer; ThreadDiameter: Real;
      IsBolt, FitWasher: Boolean; BaseColour: TColor);
   procedure TallyCalculationRecord(CalcRec:CalculationRec);
   Constructor Create;
  end;

implementation


{ TFastener }

constructor TFastener.Create;
begin
  SupportedShearLoad:=Random(90);
  SupportedTensionLoad:=Random(100);
end;

procedure TFastener.DrawPlanNut(Canvas: TCanvas; x, y: Integer;
  ThreadDiameter: Real; IsBolt, FitWasher: Boolean; BaseColour: TColor);
var
  Hex1, Hex2, Hex3, Hex4, Hex5, Hex6: Tpoint;
  i, i2: integer;
begin
  Canvas.pen.color := clBlack;
  Canvas.pen.Width := 1;
  Canvas.pen.Style := psSolid;
  Canvas.Brush.Color := BaseColour;
  Canvas.Brush.Style := bsSolid;
  i := Round(ThreadDiameter); {WasherDiameter/2}
  if FitWasher then
  begin
    Canvas.Ellipse(x - i, y - i, X + i, y + i);
{      Canvas.FloodFill(x,y,Canvas.pen.color,fsBorder);}
  end;
  i := Round(ThreadDiameter * 7 / 8); {NutApexes/2}
  Hex1.x := x - i;
  Hex4.x := x + i;
  Hex1.y := y;
  Hex4.y := y;
  i2 := i div 2;
  Hex2.x := x - i2;
  Hex6.x := hex2.x;
  Hex3.x := x + i2;
  Hex5.x := hex3.x;
  i := Round(ThreadDiameter * 7 / 8 * sin(Pi / 3)); {NutApexes/2*sin(Pi/3)}
  Hex2.y := y + i;
  Hex3.y := Hex2.y;
  Hex6.y := y - i;
  Hex5.y := hex6.Y;
  if not FitWasher then {Provide fill here}
    Canvas.polygon([Hex1, Hex2, Hex3, Hex4, Hex5, Hex6]);
  Canvas.polyLine([Hex1, Hex2, Hex3, Hex4, Hex5, Hex6, Hex1]);
  Canvas.Ellipse(x - i, y - i, X + i, y + i);
  if IsBolt then
  begin
    i := Round(ThreadDiameter * 0.6);
    Canvas.Ellipse(x - i, y - i, X + i, y + i);
  end
  else
  begin
    i := Round(ThreadDiameter * 0.5);
    Canvas.Ellipse(x - i, y - i, X + i, y + i);
    i := Round(ThreadDiameter * 0.4);
    Canvas.Ellipse(x - i, y - i, X + i, y + i);
  end;
end;

procedure TFastener.TallyCalculationRecord(CalcRec: CalculationRec);
begin
  CalcRec.TotalShear:=CalcRec.TotalShear+SupportedShearLoad;
  if CalcRec.MinShear>SupportedShearLoad then
    CalcRec.MinShear:=SupportedShearLoad;

  CalcRec.TotalTension:=CalcRec.TotalTension+SupportedTensionLoad;
  if CalcRec.MinTension>SupportedTensionLoad then
    CalcRec.MinTension:=SupportedTensionLoad;

  Inc(CalcRec.Count);
end;

end.
